((doc, win,Themify,und,vars)=> {
    'use strict';
    
    let lb,
        checkedItems,
        isSaved=false;
    const src=new URL(doc.currentScript.src,win.location.origin),
        _VER=src.searchParams.get('ver'),
        tmp = src.href.split('?')[0].replace('tbp-admin.js','').replace('tbp-admin.min.js','').slice(0, -1).trim(),
        _URL=tmp.substring(0, tmp.lastIndexOf('/') + 1),
        searchCache=new Map(),
        instances=new Map(),
        checkboxTitles=new Map(),
        cacheStates=new Map(),
    TBP = class {
        constructor(type){
            if(type){
                this.mode=type;
                instances.set(type,this);
            }
        }
        getOptions(){
            const Labels=vars.opt_labels,
                types=vars.template_types,
                {single_tax,archive_tax}=vars.options,
                func={
                    header(single,archive){
                        const singleData=this.single(single, archive,true),
                        pageData=this.page(single, archive);
                        singleData.optgroup.unshift({
                            id:'page',
                            label:Labels.page,
                            options:pageData
                        });
                        return {
                            general:{
                                label:Labels.general
                            },
                            archive:{
                                label:Labels.archive,
                                options:this.archive(single, archive,true)
                            },
                            single:{
                                label:Labels.single,
                                options:singleData
                            }
                        };
                    },
                    footer(single,archive){
                        return this.header(single,archive);
                    },
                    single(single,archive,isHeader){
                        const args = {
                                all:{
                                    label:Labels._single.all
                                },
                                is_attachment:{
                                    label:Labels.is_attachment,
                                    has_query:true
                                },
                                optgroup:[
                                    {
                                        label:Labels.p,
                                        id:'post',
                                        options:{
                                            post:Labels.post,
                                            category:Labels._single.category,
                                            post_tag:Labels._single.post_tag
                                        }
                                    }
                                ]
                            };
                            if(single && Object.keys(single).length>0){
                                if(isHeader!==true){
                                    delete single.product;
                                    args.optgroup[0].selected='post';
                                }
                                for(let k in single){
                                    args.optgroup.push(single[k]);
                                }
                            }
                            return args;
                    },
                    archive(single,archive,isHeader){
                        const args = {
                                all:{
                                    label:Labels._archive.all
                                },
                                is_date:{
                                    label:Labels.is_date
                                },
                                is_front:{
                                    label:Labels.home_latest
                                },
                                is_author:{
                                    label:Labels.is_author,
                                    has_query:true
                                },
                                is_search:{
                                    label:Labels.is_search
                                },
                                optgroup:[
                                    {
                                        label:Labels.post,
                                        id:'post',
                                        options:{
                                            all_post:Labels.all_post,
                                            category:Labels._archive.category,
                                            post_tag:Labels._archive.post_tag
                                        } 
                                    }
                                ]
                            };
                            if(vars.show_on_front!=='posts'){
                                delete args.is_front;
                            }
                            if(archive && Object.keys(archive).length>0){
                                if(isHeader!==true){
                                    delete archive.product;
                                    args.optgroup[0].selected='all_post';
                                }
                                for(let k in archive){
                                    args.optgroup.push(archive[k]);
                                }
                            }
                            return args;
                    },
                    page(){
                       const args ={
                                page:{
                                    label:Labels.page,
                                    has_query:true
                                },
                                is_front:{
                                    label:Labels.is_front,
                                    has_query:false
                                },
                                is_404:{
                                    label:Labels.is_404,
                                    has_query:false
                                },
                                child_of:{
                                    label:Labels.child_of,
                                    has_query:true
                                }
                            };
                            if(vars.show_on_front!=='page'){
                                delete args.is_front;
                            }
                            return args;
                    },
                    product_single(){
                        return {
                            product:{
                                label:Labels.product,
                                has_query:true
                            },
                            product_cat:{
                                label:Labels._single.product_cat,
                                has_query:true
                            },
                            product_tag:{
                                label:Labels._single.product_tag,
                                has_query:true
                            }
                        };  
                    },
                    product_archive(){
                            const args = {
                                all_product:{
                                    label:Labels.all_product
                                },
                                shop:{
                                    label:Labels.shop
                                }
                            },
                            taxes=vars.product_tax;
                            if(taxes){
                                for(let k=0,len=taxes.length;k<len;++k){
                                    args[ taxes[k].slug ] = {
                                        label:taxes[k].label,
                                        has_query:true
                                    };
                                }
                            }
                            return args;
                    }
                },
                conditions=[];
                
            for(let k in types){
               conditions[k] = func[k](single_tax,archive_tax); 
            }
            return [
                {
                    id:'post_title',
                    label:Labels.name,
                    type:'text'
                },
                {  
                    id:'post_parent',
                    label:Labels.theme_name,
                    help:Labels.theme_help,
                    type:'select',
                    options:vars.themes,
                    default:vars.active_theme
                },
                {
                    id:'post_mime_type',
                    label:Labels.type,
                    type:'tbp_type',
                    options:types
                },
                {
                    id:'post_excerpt',
                    label: Labels.condition,
                    type:'condition',
                    options:conditions
                }
            ];
        }
        run(id){
            this.options=this.getOptions();
            checkedItems = {};
            cacheStates.clear();
            if(!lb){
                const root = doc.tfId('tpl-tbp_builder_lightbox');
					if(root.ownerDocument!==win.top.document){
						win.top.document.body.appendChild(root);
					}
				const fr = root.firstElementChild,
                    baseCss=root.ownerDocument.tfId('tf_base-css').sheet.cssRules,
                    topCss=root.ownerDocument.tfId('tbp_top_admin-css'),
                    svg=doc.tfId('tf_svg').cloneNode(true),
                    baseStyle=doc.createElement('style'),
                    fragment=doc.createDocumentFragment(),
                    CLICK=Themify.click;
                let cssText='';
                for(let i=0,len=baseCss.length;i<len;++i){
					cssText+=baseCss[i].cssText;
                }	
				if(topCss){
					const css=topCss.sheet.cssRules;
					for(let i=0,len=css.length;i<len;++i){
						if(css[i].selectorText.includes('tb_busy')){
							cssText+=css[i].cssText;
						}
					}
				}
                baseStyle.id='tf_base';
                baseStyle.textContent=cssText;
                fragment.append(svg.cloneNode(true),baseStyle); 
                if (fr) { // shadowroot="open" isn't support
                    root.attachShadow({
                        mode: fr.getAttribute('shadowroot')
                    }).appendChild(fr.content);
                    fr.remove();
                }
                
                root.shadowRoot.prepend(fragment);
		
                lb= root.shadowRoot.querySelector('.lightbox_parent');
				if(!topCss){
					Themify.loadCss(_URL+'css/modules/top-admin','tbp_top_admin-css',_VER,lb);
				}
                lb.tfClass('close')[0].tfOn(CLICK,e=>{
                    e.stopPropagation();
                    this.close();
                },{passive:true});
                lb.tfClass('back')[0].tfOn(CLICK,e=>{
                    e.stopPropagation();
                    lb.classList.remove('step2');
                    lb.classList.add('step1');
                },{passive:true});
                for(let items=lb.querySelectorAll('.save_btn,.draft_btn'),i=items.length-1;i>-1;--i){
                    items[i].tfOn(CLICK,async e=>{
                        e.stopPropagation();
                        if(lb.classList.contains('step2') ||  TBP.id){
                            lb.classList.add('tb_busy');
                            try{
                                const [res,_Notification]=await Promise.all([this.save(e.currentTarget.classList.contains('draft_btn')),this.importNotification()]);
                                
                                await TF_Notification.showHide('done',vars.done,800);
                                isSaved=true;
                                const data=res.data;
                                if(!res.success){
                                    throw data;
                                }
                                if ( vars.type === 'tbp_theme' ) {
                                    this.close();
                                    win.location.reload();
                                }
                                else if(data.redirect && !Themify.is_builder_active){
                                   win.location.href=data.redirect;
                                }
                            }
                            catch(e){
                                await this.importNotification();
                                await TF_Notification.showHide('error',e.messsage?e.message:e,3000);
                            }
                            lb.classList.remove('tb_busy');
                        }
                        else{
                            this.next();
                        }
                    },{passive:true});
                }
            }
            else{
                lb.tfClass('lightbox')[0].innerHTML='';
            }
            const cl=lb.classList;
            cl.remove('step2');
            cl.add('step1');
            cl.toggle('new',!id);
            cl.toggle('edit',!!id);
            if(vars.type==='tbp_theme'){
                const btn=lb.tfClass('save_btn')[0];
                btn.tfClass('edit_text')[0].textContent=id && id==vars.active?btn.dataset.normal:btn.dataset.active;
            }
            lb.tfClass('lb_title')[0].textContent=id?vars.edit_template:vars.add_template;
            return this.edit(id).then(vals=>{
                this.render(this.options,vals); 
                lb.getRootNode().host.classList.remove('tf_hide');
                
                //load in background
                this.importModulePredesing();
                this.importModuleImport();
                Themify.loadJs(Themify.url+'js/admin/import/import-images',!!win.TF_ImportImages);
            });
        }
        edit(id){
            this.showLoader(true);
            TBP.id=id;
            const prms=[Themify.loadCss(_URL+'css/tbp-admin','tbp-admin-css',_VER,lb)];
            if(id){
                prms.push(Themify.fetch({id: id,action: vars.type + '_get_item',nonce: vars.nonce}));
            }
            return Promise.all(prms)
            .then(res=>{
                return res?res[1]:und;
            })
            .finally(()=>{
                this.showLoader();
            });
        }
        close(){
            lb.getRootNode().host.classList.add('tf_hide');
            if(isSaved===true&& !Themify.is_builder_active){
                win.location.reload();
            }
        }
        showLoader(show) {
            win.top.document.body.classList.toggle('tb_busy',show);
        }
        saveStep1(){
            const items = lb.tfClass('field'),
                result = {};
            for (let i = items.length - 1; i > -1; --i) {
                if (items[i].classList.contains('condition')) {
                    let conditionWrap=items[i].tfClass('condition_wrap')[0],
                        conditions = conditionWrap.tfClass('repeat'),
                        conditionsData = [];
                    for (let j = 0, len = conditions.length; j < len; ++j) {
                        conditionsData[j] = {};
                        let conditionItems = conditions[j].tfClass('repeat_inner')[0].children;
                        for (let k = conditionItems.length - 1; k > -1; --k) {
                            let cl = conditionItems[k].classList;
                            if (cl.contains('box')) {
                                if (conditionItems[k].tfClass('pagination_all')[0].checked !== true) {
                                    let index = conditions[j].dataset.index;
                                    if (checkedItems[index] !== und) {
                                        let select=conditions[j].querySelector('.query_type select');
                                        if(select===null){
                                            select=conditions[j].querySelector('.general select');
                                        }
                                        if(select!==null && checkedItems[index][select.value] && Object.keys(checkedItems[index][select.value]).length>0){
                                            conditionsData[j].detail = checkedItems[index][select.value];
                                        }
                                    }
                                }
                            }
                            else if (cl.contains('include') || cl.contains('selectwrapper')) {
                                let select = conditionItems[k].tfTag('select')[0];
                                if (select.value !== 'in') {
                                    conditionsData[j][select.dataset.id] = select.value;
                                }
                            }
                        }
                    }
                    result[conditionWrap.id] = conditionsData;
                }
                else {
                    let inputs=items[i].querySelectorAll('input,select,textarea');
                    for(let j=inputs.length-1;j>-1;--j){
                        let v=inputs[j].value.trim();
                        if(v){
                            result[inputs[j].id] =v;
                        }
                    }
                }
            }
            return result;
        }
        importModuleImport(){
            return Themify.loadJs(Themify.url+'js/admin/import/import',!!win.TF_Import);
        }
        importModulePredesing(){
            return Themify.loadJs(_URL+'js/modules/predesigned',!!win.TBP_Predesigned,_VER);
        }
        importModuleFile(){
            Themify.loadJs(Themify.url+'js/admin/jszip.min',!!win.JSZip,'3.10.1');//parallel loading
            return Themify.loadJs(_URL+'js/modules/import-file',!!win.TBP_ImportFromFile,_VER);
        }
        importTemplate(themeId,data,action){
            const templates=this.convertToV7(data.posts || data);
            if(themeId){
                for(let i=templates.length-1;i>-1;--i){
                    templates[i].post_parent=themeId;
                }
            }
            if(!action){
                action='templates';
            }
            return this.import(action,templates);
        }
        async importNotification(){
            await Themify.loadJs(Themify.url+'js/admin/notification',!!win.TF_Notification);
            await TF_Notification.init();
        }
        convertToV7(templates){
            for(let i=templates.length-1;i>-1;--i){
                let item=templates[i],
                    opt=item.tbp_template_options || item,
                    builder=item.builder_data || item.template_builder_content;
                if(!builder){
                    builder=item.settings;
                }
                if(opt.tbp_template_name && (!item.post_title || item.post_title.length<2)){
                    item.post_title=opt.tbp_template_name;
                }
                if(opt.title  && (!opt.post_title || item.post_title.length<2)){
                    item.post_title=opt.title;
                }
                if(opt.tbp_associated_theme && (!item.post_parent || item.post_parent==='0')){
                    item.post_parent=opt.tbp_associated_theme;
                }
                if(opt.tbp_template_type && (!item.post_mime_type || item.post_mime_type.length<2)){
                    item.post_mime_type='/'+opt.tbp_template_type;
                }
                if(item.post_mime_type[0]!=='/'){
                    item.post_mime_type='/'+item.post_mime_type;
                }
                if(opt.tbp_template_conditions && (!item.post_excerpt || item.post_excerpt.length<2)){
                    item.post_excerpt=JSON.stringify(opt.tbp_template_conditions);
                }
                else if(item.post_excerpt && typeof item.post_excerpt!=='string'){
                    item.post_excerpt=JSON.stringify(item.post_excerpt);
                }
                if(builder && (!item.meta_input || item.meta_input._themify_builder_settings_json)){
                    if(!item.meta_input){
                        item.meta_input={};
                    }
                    item.meta_input._themify_builder_settings_json=typeof builder==='string'?JSON.parse(builder):builder;
                }
                if(!item.ID){
                    item.ID=item.id?item.id:(Date.now()+i);
                }
                delete item.settings;
                delete item.id;
                delete item.title;
                delete item.builder_data;
                delete item.template_builder_content;
                delete item.tbp_template_conditions;
                delete item.tbp_associated_theme;
                delete item.tbp_template_name;
                delete item.tbp_template_type;
                delete item.tbp_template_options;
            }
            return templates;
        }
        next(){
            const res=this.saveStep1(),
                type=res.post_mime_type || 'theme',
                prms=[Themify.loadCss(_URL+'css/modules/predesigned','tbp-predesigned-css',_VER,lb),this.importModulePredesing()],
                step2=lb.querySelector('.lightbox.step2'),
            _predesigned=new Promise((resolve,reject)=>{
                prms[1].then(()=>{
                    const f=type==='theme'?'getThemes':'getTemplates';
                    TBP_Predesigned[f](type).then(resolve).catch(reject);
                })
                .catch(reject);
            });
            if(step2.tfClass('predesigned_'+type)[0]===und){
                lb.classList.add('tb_busy');
            }
            prms.push(_predesigned);
           
            return Promise.all(prms)
            .then(res=>{
                if(lb.classList.contains('tb_busy')){
                    step2.innerHTML='';
                    step2.appendChild(TBP_Predesigned.getHtml(res[2],type,vars));
                }
                return res;
            })
            .finally(()=>{
                lb.classList.add('step2');
                lb.classList.remove('step1','tb_busy');
            });
        }
        async save(is_draft){
            try{
                const prms=[],
                    type=vars.type,
                    req={
                        id: TBP.id || '',
                        is_draft: is_draft?1:0,
                        action: type + '_saving',
                        data: this.saveStep1(),
                        nonce: vars.nonce
                    },
                    pr=type==='tbp_theme'?Themify.fetch(req):'';
                prms.push(pr);
                if(!TBP.id && lb){
                    const selectLayout = lb.querySelector('.predesigned .selected');
                    if(selectLayout){
                        const slug=selectLayout.dataset.slug;
                        if(slug!=='blank'){
                            const p=new Promise(async(resolve,reject)=>{
                                await this.importModulePredesing();
                                const f=type==='tbp_theme'?'getTheme':'getTemplate',
                                    _p=[TBP_Predesigned[f](slug)];
                                if(selectLayout.querySelector('.import_demo input:checked')){
                                    _p.push(TBP_Predesigned.getThemeDemo(slug));
                                }
                                Promise.all(_p).then(resolve).catch(reject);
                            });
                            prms.push(p);
                        }
                    }
                }
                let [save,demo]=await Promise.all(prms);
                if(type!=='tbp_theme'){           
                    if(demo){
                        let builder = demo[0][0].template_builder_content || demo[0][0].builder_content || '';
                        if(builder){
                            if(typeof builder==='string'){
                                builder=JSON.parse(builder);
                            }
                            req.data.builder=builder;
                        }
                    }
                    save=await Themify.fetch(req);
                    demo=null;
                }
                if(save.data && save.data.id){
                    TBP.id=save.data.id;
                    if(demo){
                        const [templates,demoData]=demo;
                        if(templates){
                            await this.importTemplate(TBP.id,templates);
                            if(demoData){
                                await this.importDemo(TBP.id,demoData);
                            }
                        }
                    }
                }
                else{
                    throw save.data?save.data:'error';
                }
                return save;
            }
            catch(e){
                throw e;
            }
        }
        getIcon(ic){
            const ns = 'http://www.w3.org/2000/svg',
                use = doc.createElementNS(ns, 'use'),
                svg = doc.createElementNS(ns, 'svg');
                
            ic = 'tf-' + ic.trim().replace(' ', '-');
            svg.setAttribute('class', 'tf_fa ' + ic);
            use.setAttributeNS(null, 'href', '#' + ic);
            svg.appendChild(use);
            return svg;  
        }
        render(data,vals){
            if(!vals){
                vals={};
            }
            const CLICK=Themify.click,
                self=this,
                ext = doc.createElement('canvas').toDataURL('image/webp').includes('data:image/webp') ? 'webp' : 'png',
                constrols={
                text:{
                    render(args,val){
                        const input=doc.createElement('input');
                        input.type='text';
                        input.id=input.name=args.id;
                        if(args.class){
                            input.className=args.class;
                        }
                        if(val){
                            input.value=val;
                        }
                        return input;
                    }
                },
                select:{
                    render(args,val){
                        const select=doc.createElement('select'),
                            wrap=doc.createElement('div'),
                            fr=doc.createDocumentFragment(),
                            selected=val || args.default;
                        for(let k in args.options){
                            let opt=doc.createElement('option');
                            opt.value=k;
                            opt.textContent=args.options[k];
                            if(selected==k){
                                opt.selected=true;
                            }
                            fr.appendChild(opt);
                        }
                        select.appendChild(fr);
                        select.className='tf_scrollbar tf_w';
                        if(args.id){
                            select.id=select.name=args.id;
                        }
                        wrap.className='selectwrapper tf_overflow tf_rel';
                        if(args.wrap_class){
                            wrap.className+=' '+args.wrap_class;
                        }
                        wrap.appendChild(select);
                        return wrap;
                    }
                },
                description:{
                  render(msg){
                      const small= doc.createElement('small');
                      small.textContent=msg;
                      small.className='tf_block';
                      return small;
                  }  
                },
                image:{
                    render(args, val) {
                        const wr = doc.createElement('div'),
                            thumb = doc.createElement('div'),
                                input = doc.createElement('input'),
                                attachInput=doc.createElement('input'),
                                upload_btn = doc.createElement('button'),
                                btn_delete = doc.createElement('button'),
                                deleteImage=()=>{
                                    input.value=attachInput.value='';
                                    if(btn_delete.previousElementSibling){
                                        btn_delete.previousElementSibling.remove();
                                    }
                                },
                                setImage=url=>{
                                    if (url) {
                                        const w = 50,
                                            h = 50,
                                            img = new Image(w,h),
                                            placeholder=new Image(w,h);
                                        placeholder.decoding = 'async';
                                        placeholder.src = '//via.placeholder.com/'+w+'x'+h+'.'+ext;
                                        thumb.classList.add('tb_busy');
                                        img.src = url;
                                        img.decoding = 'async';
                                        img.decode().finally(() => {
                                            placeholder.replaceWith(img);
                                            thumb.classList.remove('tb_busy');
                                        });
                                        thumb.prepend(placeholder);
                                    }
                                };
                        attachInput.type=input.type = 'hidden';
                        input.id = args.id;
                        attachInput.id=args.id+'_id';
                        if (val !== und) {
                            input.value = val;
                            if(vals[attachInput.id]){
                                attachInput.value = vals[attachInput.id];
                            }
                        }
                        btn_delete.className = 'tf_close delete_img tf_hide';
                        upload_btn.className = 'upload_btn plus flex tf_rel';
                        btn_delete.type=upload_btn.type = 'button';
                        upload_btn.textContent = vars.upload_image;
                        wr.className = 'upload_wrap tf_rel';
                        thumb.className='img_preview';
                        thumb.appendChild(btn_delete);
                        wr.append(input,attachInput,upload_btn,thumb);
                        if(args.description){
                            wr.appendChild(constrols.description.render(args.description));
                        }
                        btn_delete.tfOn(CLICK, e=> {
                            e.stopPropagation();
                            deleteImage();
                        });
                        upload_btn.tfOn(CLICK, e=> {
                            e.stopPropagation();
                            let file_frame;
                                file_frame = wp.media.frames.file_frame = wp.media({
                                    title: vars.upload_image,
                                    library: {
                                        type:'image'
                                    },
                                    button: {
                                        text:vars.upload_image
                                    },
                                    multiple: false
                                });
                            file_frame.off('select').on('select', ()=> {
                                deleteImage();
                                const attachment = file_frame.state().get('selection').first().toJSON();
                                input.value = attachment.url;
                                Themify.triggerEvent(input, 'change');
                                const attach_id = input.getRootNode().querySelector('#' + input.id + '_id');
                                if (attach_id) {
                                    attachInput.value = attachment.id;
                                }
                            });
                            // Finally, open the modal
                            file_frame.open();
                            file_frame.content.mode('browse');
                        },{passive:true});
                        input.tfOn('change', e=>{
                           setImage(e.currentTarget.value.trim());
                        }, {passive: true});
                        setImage(val);
                        return wr;
                    }
                },
                tbp_type:{
                    render(args,val){
                        const selectWrap = constrols.select.render(args, val),
                            select=selectWrap.tfTag('select')[0];
                        self.type=val || select.value;
                        select.tfOn('change', e=> {
                            e.stopPropagation();
                            cacheStates.set(self.type,self.saveStep1());
                            
                            self.type = e.currentTarget.value;
                            
                            let opt;
                            for(let i=data.length-1;i>-1;--i){
                                if(data[i].type==='condition'){
                                    opt=data[i];
                                    break;
                                }
                            }
                            const id=opt.id,
                                wrap=lb.querySelector('#'+id),
                                editVals=cacheStates.get(self.type) || {};
                            wrap.innerHTML='';
                            wrap.parentNode.replaceChild(constrols.condition.render(opt,editVals[id]),wrap);
                        }, {passive: true});
                        return selectWrap;
                    }
                },
                condition:{
                    options:{},
                    render(args, vals) {
                        const wrap=doc.createElement('div'),
                            f = doc.createDocumentFragment(),
                            add = doc.createElement('button');
                        wrap.id = args.id;
                        wrap.className='condition_wrap';
                        add.className = 'add plus tf_textl tf_rel';
                        add.type='button';
                        add.textContent = vars.add_conition;
                        if(!vals || vals.length === 0){
                            vals=[{}];
                        }
                        this.options=args.options;
                        for (let i = 0, len = vals.length; i < len; ++i) {
                            f.appendChild(this.renderRepeat(this.options[self.type], i, vals[i]));
                        }
                        
                        f.appendChild(add);
                        wrap.tfOn(CLICK, e=> {
                            const target=e.target?e.target.closest('.add,.delete'):null;
                            if(target){
                                e.stopPropagation();
                                if(target.classList.contains('delete')){
                                    const repeat=target.closest('.repeat'),
                                        index = repeat.dataset.index;
                                    if (checkedItems[index] !== undefined) {
                                        delete checkedItems[index];
                                    }
                                    repeat.remove();
                                }
                                else{
                                    target.before(this.renderRepeat(this.options[self.type], null, {}));
                                }
                            }
                            
                        },{passive:true})
                        .appendChild(f);
                        return wrap;
                        
                    },
                    renderRepeat(options, index, vals) {
                        const repeat = doc.createElement('div'),
                            repeatInner = doc.createElement('div'),
                            deleteBtn = doc.createElement('button');
                            repeat.className = 'repeat flex';
                            repeatInner.className = 'repeat_inner';
                            index=index !== null ? index : this.setIndex();
                            repeat.dataset.index=index;
                            deleteBtn.className = 'tf_close delete';
                            deleteBtn.type = 'button';
                            repeatInner.append(this.includeRender(vals),this.renderGeneral(options, vals, index));
                            repeat.append(repeatInner,deleteBtn);

                        return repeat;
                    },
                    includeRender(vals) {
                        const wrap= constrols.select.render({
                                    wrap_class:'include flex',
                                    options: {
                                        in: vars.include,
                                        ex: vars.exclude
                                    }
                                },vals.include);
                        wrap.classList.remove('selectwrapper','tf_overflow');
                        wrap.tfTag('select')[0].dataset.id='include';
                        return wrap;
                    },
                    renderGeneral(options, vals,index) {
                        let queryVals=vals.query,
                            detailsVals=vals.detail;
                        const key='general',
                            selectWrap = this.renderSelect(options,vals[key],key,key),
                            select=selectWrap.tfTag('select')[0],
                            fr=doc.createDocumentFragment(),
                            bindChange=(select,id)=>{
                                select.tfOn('change', e=>{
                                    e.stopPropagation();
                                    selectChange(e.currentTarget);
                                }, {passive: true})
                                .dataset['id']=id;
                            },
                            selectChange=el=>{
                                    const v=el.value,
                                        opt = this.options[self.type][v],
                                        p=el.closest('.selectwrapper'),
                                        item=el.options[el.selectedIndex],
                                        next=p.nextSibling;
                                    let	isQury=item.dataset.hasQuery=='1';
                                        if(next!==null){
                                            const queryNext = next.nextSibling;
                                            next.remove();
                                            if(queryNext!==null){
                                                queryNext.remove();
                                            }
                                        }
                                    if(opt!==undefined){
                                        if(opt.options!==undefined){
                                            const query = this.renderSelect(opt.options,queryVals,'query_type'),
                                                querySelect=query.tfTag('select')[0];
                                                bindChange(querySelect, 'query');
                                                p.after(query);
                                                if(queryVals ){
                                                    selectChange(querySelect);
                                                }
                                        }
                                    }
                                    else if(isQury===false && !item.hasAttribute('data-hasQuery')){
                                        const group=item.parentNode,
                                            id=group.nodeName==='OPTGROUP'?group.dataset.id:false;
                                            isQury=id && 'all_'+id!==v;
                                    }
                                    if(isQury===true){
                                        p.after( this.renderSinlgeItems(detailsVals,v,index));
                                    }
                            };
                            fr.appendChild(selectWrap);
                            bindChange(select,key);
                            selectChange(select);
                            queryVals=detailsVals=und;
                            return fr;
                    },
                    renderSelect(options,selected,cl){
                            const f = doc.createDocumentFragment(),
                                select = constrols.select.render({wrap_class:cl}),
                                makeOptions = (val,label,has_query,def)=>{
                                const opt = doc.createElement('option');
                                    opt.value = val;
                                    opt.textContent = label;
                                    if(val===selected || (def===val && TBP.id===null)){
                                        opt.selected = true;
                                    }
                                    if(has_query!==und){
                                        opt.dataset.hasQuery=has_query?1:0;
                                    }
                                    return opt;
                            };
                            for (let i in options) {
                                if(i==='optgroup'){
                                    for(let j=0,len=options[i].length;j<len;++j){
                                        let group = doc.createElement('optgroup'),
                                            groupF = doc.createDocumentFragment();
                                        group.label = options[i][j].label;
                                        group.dataset.id= options[i][j].id;
                                        for (let k in options[i][j].options) {
                                            let item=options[i][j].options[k];
                                            groupF.appendChild(makeOptions(k, item.label!==und?item.label:item,item.has_query,options[i][j].selected));
                                        }
                                        group.appendChild(groupF);
                                        f.appendChild(group);
                                    }
                                }
                                else{
                                    f.appendChild(makeOptions(i,options[i].label,options[i].has_query,options[i].selected));
                                }
                            }
                        select.tfTag('select')[0].appendChild(f);
                        return select;
                    },
                    renderSinlgeItems(vals,query, index) {
                        let timer;
                        const wrap = doc.createElement('div');
                        wrap.className = 'box selectwrapper tf_rel';
                        wrap.tabIndex='-1';
                        wrap.appendChild(doc.getElementById('tmpl-tbp_box').content.cloneNode(true));
                        const checkbox = wrap.tfClass('pagination_all')[0],
                                header = wrap.tfClass('select_all')[0],
                                all=wrap.tfClass('pagination_all')[0],
                                labelId='tbp_'+Math.random().toString(36).substr(2, 7),
                                searchItem = e=> {
                                    e.stopPropagation();
                                    if(timer){
                                        clearTimeout(timer);
                                    }
                                    const v= e.currentTarget.value;
                                    timer=setTimeout(()=>{
                                        this.loadData(wrap, 1, v);
                                    },10);
                                },
                                onChange =  el=> {
                                    header.textContent = !el.checked?header.dataset.select:header.dataset.all;
                                };

                        checkbox.tfOn('change', e=> {
                            e.stopPropagation();
                            this.loadData(wrap).then(()=>{
                                this.setSelected(wrap);
                            });
                            onChange(e.currentTarget);
                        }, {passive: true});  
                        
                        if (query !== und && vals) {
                            checkbox.checked = false;
                            const repeat = wrap.closest('.repeat');
                            if(repeat!==null){
                                index = repeat.dataset.index;
                            }
                            if(checkedItems[index]===und){
                                checkedItems[index] ={};
                            }
                            if(checkedItems[index][query]===und){
                                checkedItems[index][query] ={};
                            }
                            checkedItems[index][query] = vals;
                            
                            header.tfOn('pointerdown', e=>{
                                e.stopPropagation();
                                this.loadData(wrap).then(()=>{
                                    this.setSelected(wrap);
                                }); 
                            }, {passive: true,once:true});
                            onChange(checkbox);
                        }
                        all.id=labelId;
                        all.previousElementSibling.setAttribute('for',labelId);
                        wrap.tfClass('search')[0].tfOn('input', searchItem,{passive:true});
                        wrap.tfClass('result_wrap')[0].tfOn('change', e=>{
                            this.saveCheckboxes(e.currentTarget);
                            this.setSelected(e.currentTarget);
                        },{passive:true});
                        wrap.tfClass('selected_wrap')[0].tfOn(CLICK, e=>{
                            const target=e.target?e.target.closest('.delete_sel'):null;
                            if(target){
                                e.stopPropagation();
                                const id=target.closest('[data-id]').dataset.id,
                                    wrap=target.closest('.search_wrap'),
                                    checkbox=wrap.querySelector('input[value="'+id+'"][type="checkbox"]'),
                                    checked=this.getCheckedItems(wrap);
                                if(checkbox){
                                    checkbox.checked=false;
                                }
                                delete checked[id];
                                this.setSelected(e.currentTarget);
                                wrap.closest('[tabindex]').focus();
                            }
                        },{passive:true});
                        return wrap;
                    },
                    setSelected(el){
                        const f=doc.createDocumentFragment(),
                            repeat=el.closest('.repeat'),
                            select=repeat.tfClass('selected_wrap')[0],
                            checkboxes=repeat.tfClass('result')[0].tfTag('input'),
                            not_found=[],
                            items=this.getCheckedItems(repeat);
                            let queryType=repeat.querySelector('.query_type select');
                            if(queryType===null){
                                queryType=repeat.querySelector('.general select');
                            }
                            queryType=queryType.value;
                        for(let i=checkboxes.length-1;i>-1;--i){
                            let k=checkboxes[i].name+checkboxes[i].value;
                            if(!checkboxTitles.has(k)){
                                checkboxTitles.set(k,checkboxes[i].parentNode.title);
                            }
                        }
                        for(let i in items){
                            let item=doc.createElement('li'),
                                del=doc.createElement('button'),
                                text=doc.createElement('div'),
                                title=checkboxTitles.get(queryType+i);
                            text.innerHTML=text.title=title || i;
                            text.className='sel_text tf_overflow';
                            del.type='button';
                            del.className='delete_sel tf_close';
                            item.dataset.id=i;
                            item.append(text,del);
                            f.appendChild(item);
                            if(title===und){
                                not_found.push(i);
                            }
                        }
                        select.innerHTML='';
                        if(not_found.length>0){
                            select.classList.add('tb_busy');
                            Themify.fetch({
                                action: 'tbp_get_titles',
                                data: not_found,
                                type:queryType,
                                nonce: vars.nonce
                            })
                            .then(res=>{
                                if(res.success){
                                    const data=res.data,
                                        exist=data.exist,
                                        deleted=data.deleted;
                                    for(let i in exist){
                                        checkboxTitles.set(queryType+i,exist[i]);
                                    }
                                    if(deleted){
                                        for(let i=deleted.length-1;i>-1;--i){
                                            delete items[deleted[i]];
                                        }
                                    }
                                    this.setSelected(el);
                                }
                            })
                            .finally(()=>{
                                select.classList.remove('tb_busy');
                            });
                        }
                        select.appendChild(f);
                    },
                    loadData(wrap, page, search) {
                        return new Promise((resolve,reject)=>{
                            
                            let theSelected = wrap;
                            while (theSelected !== null) {
                                theSelected = theSelected.previousElementSibling;
                                if (theSelected.classList.contains('selectwrapper') && theSelected.offsetParent !== null) {
                                    break;
                                }
                            }
                            if (theSelected !== null) {
                                page = parseInt(page) || 1;
                                const res = wrap.tfClass('result_wrap')[0],
                                        type = theSelected.tfTag('select')[0].value,
                                        cacheKey=type+search+page,
                                        resp=searchCache.get(cacheKey);
                                let prms=Promise.resolve(resp);
                                if (this.xhr) {
                                    this.xhr.abort();
                                }
                                this.saveCheckboxes(wrap);
                                if (!resp) {
                                    this.xhr = new AbortController();
                                    res.classList.add('tb_busy');
                                    prms=Themify.fetch({
                                        action: 'tbp_load_data',
                                        p: page,
                                        s: search || '',
                                        type: type,
                                        nonce: vars.nonce
                                    },'json', {signal: this.xhr.signal})
                                    .then(res=>{
                                        res=res.data;
                                        searchCache.set(cacheKey,res);
                                        return res;
                                    })
                                    .finally(()=>{
                                        res.classList.remove('tb_busy');
                                    });
                                } 
                                prms.then(resp=>{
                                    const wrapResult = doc.createElement('div'),
                                        f = doc.createDocumentFragment(),
                                        data = resp.data,
                                        count = resp.count,
                                        limit = resp.limit,
                                        checked=this.getCheckedItems(wrap);
                                    res.innerHTML = '';  
                                    wrapResult.className = 'result tf_scrollbar';
                                    for (let i in data) {
                                        let label = doc.createElement('label'),
                                            span=doc.createElement('span'),
                                            input = doc.createElement('input');
                                        input.type = 'checkbox';
                                        input.value = i;
                                        input.name = type;
                                        if (checked[i] !== und) {
                                            input.checked = true;
                                        }
                                        span.innerHTML= label.title=data[i];
                                        label.append(input,span);
                                        f.appendChild(label);
                                    }
                                    wrapResult.appendChild(f);
                                    res.appendChild(wrapResult);
                                    if (count > limit) {
                                        const pagination = doc.createElement('div'),
                                            pf = doc.createDocumentFragment();
                                        pagination.className = 'pagination flex';
                                        for (let i = 1, n = Math.ceil(count / limit); i <= n; ++i) {
                                            let btn = doc.createElement('button');
                                            btn.className = 'page';
                                            btn.type='button';
                                            btn.textContent = i;
                                            if (page === i) {
                                                btn.className += ' current';
                                            }
                                            btn.dataset.number= i;
                                            pf.appendChild(btn);
                                        }
                                        pagination.tfOn(CLICK, e=> {
                                            e.stopPropagation();
                                            const p = e.target.dataset.number;
                                            if (p) {
                                                this.loadData(wrap,p, search);
                                            }
                                        },{passive:true})
                                        .appendChild(pf);
                                        res.appendChild(pagination);
                                    }
                                    if(search === undefined){
                                        wrap.closest('.box').focus();
                                    }
                                    resolve([vals, res, page]);
                                })
                                .catch(e=>{
                                    if(e.name==='AbortError'){
                                        resolve();
                                    }
                                    else{  
                                        reject(e);
                                    }
                                });
                            }
                            else{
                                reject();
                            }
                        });
                    },
                    saveCheckboxes(wrap) {
                        const checkboxes = wrap.tfTag('input'),
                            repeat=wrap.closest('.repeat'),
                            index = repeat.dataset.index;
                            let queryType=repeat.querySelector('.query_type select');
                            if(queryType===null){
                                queryType=repeat.querySelector('.general select');
                            }
                            queryType=queryType.value;
                        if (checkedItems[index] === und) {
                            checkedItems[index] = {};
                        }
                        if (checkedItems[index][queryType] === und) {
                            checkedItems[index][queryType] = {};
                        }
                        
                        for (let i = checkboxes.length - 1; i > -1; --i) {
                            let v = checkboxes[i].value;
                            if (checkboxes[i].checked === true) {
                                checkedItems[index][queryType][v] = true;
                            }
                            else if (checkedItems[index][queryType][v] !== und) {
                                delete checkedItems[index][queryType][v];
                            }
                        }
                    },
                    getCheckedItems(wrap){
                        const repeat=wrap.closest('.repeat'),
                            index = repeat.dataset.index;
                        let queryType=repeat.querySelector('.query_type select');
                            if(queryType===null){
                                queryType=repeat.querySelector('.general select');
                            }
                            queryType=queryType.value;
                            return checkedItems[index][queryType] || {};
                    },
                    setIndex() {
                        const repeats = lb.tfClass('repeat');
                        let max = repeats[0] !== undefined ? (parseInt(repeats[0].dataset.index)) : 0;
                        for (let i = repeats.length - 1; i > 0; --i) {
                            let index = parseInt(repeats[i].dataset.index);
                            if (max < index) {
                                max = index;
                            }
                        }
                        return ++max;
                    }
                }
            },
            fr=doc.createDocumentFragment();
            if(!TBP.id && !vars.active && vars.type!=='tbp_theme'){
                lb.classList.add('no_active');
                const noActive=doc.createElement('div');
                noActive.className='no_theme flex';
                noActive.innerHTML=vars.no_active;
                noActive.prepend(this.getIcon('ti-alert'));
                fr.appendChild(noActive);
            }
            else{
                for(let i=0,len=data.length;i<len;++i){
                    let field=doc.createElement('div'),
                    label=doc.createElement('label');

                    label.className='flex';
                    label.textContent=data[i].label;
                    label.htmlFor=data[i].id;
                    if(data[i].help){
                        let help=doc.createElement('span'),
                            helpIcon=doc.createElement('button'),
                            helpText=doc.createElement('span');
                        help.className='help tf_rel';

                        helpIcon.type='button';
                        helpIcon.className='help_icon';
                        helpText.className='help_text tf_box tf_hide';
                        helpText.innerHTML=data[i].help;
                        helpIcon.appendChild(this.getIcon('ti-help'));
                        help.append(helpIcon,helpText);
                        label.appendChild(help);
                    }
                    field.className='field '+data[i].type;
                    field.append(label,constrols[data[i].type].render(data[i],vals[data[i].id]));
                    fr.appendChild(field);
                }
            }
            lb.tfClass('lightbox')[0].appendChild(fr);
        }
        async export(ids){
            this.showLoader(true);
            await Promise.all([Themify.loadJs(_URL+'js/modules/export',!!win.TBP_ExportFile,_VER),this.importNotification()]);
            try{
                await TBP_ExportFile.init(ids,vars.type,vars);
                TF_Notification.showHide('done',vars.done);
            }
            catch(e){
				TF_Notification.showHide('error',e,3000);
                throw e;
            }
            finally{
                this.showLoader();
            }
        }
        importFile(){
            const fileInput=doc.createElement('input'),
                self=this;
            fileInput.type='file';
            fileInput.accept='.zip,.txt';
            fileInput.tfOn('change',async function(e){
                    this.remove();
                    const file=this.files[0];
                    self.showLoader(true);
                    try{
                        await Promise.all([self.importModuleFile(),self.importNotification(),self.importModuleImport()]);
                        const res=await TBP_ImportFromFile.init(file,self,vars);
                        await TF_Notification.showHide('done',vars.done,1500);
                        if(res && res.redirect && vars.type==='tbp_theme' && confirm(vars.theme_imported.replaceAll('%post%',res.title))){
                            win.location.href=res.redirect;
                        }
                        else{
                          win.location.reload();
                        }
                    }
                    catch(e){
                        await TF_Notification.showHide('error',e,5000);
                    }
                    self.showLoader();
            },{passive:true,once:true})
            .click();
        }
        async import(type,posts){
            await Promise.all([this.importModuleImport(),this.importNotification()]);
            const memory=vars.memory;
            vars.images_chunk=memory>=255?6:(memory>=120?5:(memory>60?3:2));
            if(type==='menu'){
                await TF_Notification.show('info',vars.import_menu);
                const data={id:'tbp',nonce:vars.nonce,action:'tbp_ajax_import',data:posts,type:type};
                try{
                    const response=await Themify.fetch(data);
                    if(!response.success){
                        throw 'error';
                    }
                }
                catch(e){
                    try{
                        data.data=new Blob( [JSON.stringify(data.data)], { type: 'application/json' });
                        const response=await Themify.fetch(data);
                        if(!response.success){
                            throw 'error';
                        }
                    }
                    catch(e){
                        throw e;
                    }
                }
            }
            else{
                vars.loading=vars['import_'+type];
                vars.custom_params={type:type};
                if(type!=='templates' && type!=='file_templates'){
                    if(type==='menu_items'){
                        posts=TF_Import.sort(posts,'meta_input','_menu_item_menu_item_parent');
                    }
                    else{
                        posts=type==='terms'?TF_Import.sort(posts,'parent'):TF_Import.sort(posts,'post_parent');
                    }
                }
                const res=await TF_Import.init(posts,'tbp_ajax_import',vars.nonce,vars,'tbp','tbp_ajax_import');
                delete vars.custom_params;
                return res;
            }
        }
    };
    
    
    const init=()=>{
        const adBtn = doc.tfClass('page-title-action')[0],
            import_btn = doc.createElement('button');
        if(adBtn && vars.import_btn){
            import_btn.type='button';
            import_btn.className = 'tbp_admin_import add-new-h2';
            import_btn.textContent = vars.import_btn;
            adBtn.after(import_btn); 
        }
        doc.tfOn([Themify.click,'tbp_edit'],e=>{
            let target=e.detail instanceof HTMLElement?e.detail:e.target;
			if(target){
				target=target.closest('.tbp_lightbox_edit,.page-title-action,.tbp_admin_import,.tbp_export,#doaction');
				if(target){
					let isSubmit=target.id==='doaction';
					if(isSubmit){
						const select=target.closest('form').querySelector('select[name="action"]');
						if(!select || select.value!=='bulk-export'){
							return;
						}
					}
					e.preventDefault();
					e.stopPropagation();
					Themify.trigger('tbp_layout_loaded',[TBP]);
					const type=vars.type.split('_')[1],
						obj=instances.get(type)|| (new TBP());
						
					obj.importNotification();
					obj.importModuleImport();
					if(isSubmit || target.classList.contains('tbp_export')){
						let templates={};
						if(type!=='theme'){
							if(isSubmit){
								const checked=doc.tfId('the-list').querySelectorAll('input[name="post[]"]:checked');
								if(checked.length===0){
									return;
								}
								for(let i=checked.length-1;i>-1;--i){
									templates[checked[i].value]=checked[i].closest('tr').querySelector('.row-title').textContent;
								}
							}
							else{
								templates[e.target.dataset.postId]=target.closest('tr').querySelector('.row-title').textContent;
							}
						}
						else{
							templates=[e.target.dataset.postId];
						}
						obj.export(templates);
					}
					else if(target.classList.contains('tbp_admin_import')){
						obj.importFile();
					}
					else{
						obj.run(target.dataset.postId);
					}
				} 
			}
        });
        
        Themify.trigger('tbp_ready',[TBP]);
    };
    
	if (doc.readyState === 'complete') {
        init();
	} else {
		win.tfOn('load',init, {once:true, passive:true});
	}

})(document, window,Themify,undefined,_tbp_admin);